unit dkTranslator;
interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;
//const deeNone=0;dee44=1;dee32=2;dee48=3;
//const vrSlow=1;vrFast=0;
type TDeemph=(deeNone,dee44,dee32,dee48);
type TVolRamp=(vrSlow,vrFast);
type TAD1954=    class
                public
                 //konstruktor, zakladni HW komunikace
                 constructor CreateLPT(PortAddr,CLatchPort,CLatchVal:integer;neg:boolean);   {vytvori objekt}
                 procedure Init;                        {inicializuje AD1954}
                 procedure NoVoltage(value:boolean);    {pri pouziti LPT da pri
                                                        true vsechny piny
                                                        do nuly}
                 //ovladani kontr. registru
                 procedure SetMute(Value:boolean);
                 function GetMute:boolean;
                 procedure SetPowerDown(Value:boolean);
                 function GetPowerDown:boolean;
                 procedure SetDeemphasis(Value:TDeemph);
                 function GetDeemphasis:TDeemph;
                 procedure SetVolumeRamp(Value:TVolRamp);
                 function GetVolumeRamp:TVolRamp;
                 procedure SetInput(Value:integer);
                 function GetInput:integer;
                 procedure SetMCLK(Value:integer);
                 function GetMCLK:integer;
                 //hlasitost
                 procedure SetVolLeft(Value:real);
                 procedure SetVolRight(Value:real);
                 procedure SetVolSub(Value:real);
                 //ovladani Biquad filtru
                 function BiquadEQ(id:integer;safeload:boolean;freq,q,dBgain:real):boolean;
                        //vrati false, pokud nelze filtr vytvorit
                 function BiquadGain(id:integer;safeload:boolean;dBgain:real):boolean;
                        //vrati false, pokud nelze filtr vytvorit


                 //prime zadani prikazu
                 procedure Cmd(addr:integer;data1,data2:byte);overload;
                 procedure Cmd(addr:integer;data220:real);overload;
                 procedure CmdSafe(addr:integer;data220:real);
                 procedure Cmd(addr:integer;data1,data2,data3:byte);overload;
                 procedure Cmd(addr:integer;data1,data2,data3,data4:byte);overload;
                 procedure Reset;
                 function GetCapture(address:integer):integer;
                public
                 ADLATCHPORT,ADLATCHVAL:integer;ADNEG:boolean;
                protected
                 uselpt:boolean;
                 port:integer;
                 control1:longint;
                 control2:longint;
                 volleft:integer;
                 volright:integer;
                 volsub:integer;
                 procedure SendControl1;
                 procedure SendControl2;
                end;

function RealTo220(r:real):integer;
Function Mocnina(x,m:real):real;
type
  E220RangeException = class(Exception);

implementation
uses LPTComm;

Function Mocnina(x,m:real):real;
Begin
Mocnina:=Exp(m*(Ln(x)));
end;


function RealTo220(r:real):integer;
var y:longint;
begin
 y:=0; //aby kompiler notravoval s WARNING:... might not be initialized
 if r>1.99999 then r:=1.9999;
 if r<-1.99999 then r:=-1.999;
 if r=0 then y:=0;
 if r>0 then begin
  y:=round(1048576*r);
  if y>(2*1048576-1) then begin
   E220RangeException.Create('Prekrocen rozsah');
   y:=1048576;
  end;
 end;
 if r<0 then begin
  r:=abs(r);
  y:=round(4194303-r*1048576);
  if y<2*1048576 then begin
   E220RangeException.Create('Prekrocen rozsah');
   y:=1048576;
  end;
 end;
 result:=y;
end;

function TAD1954.GetCapture(address:integer):integer;
begin
 CommStart(ADLATCHPORT,ADLATCHVAL,ADNEG);
 SendByte((address div $100)+4);
 SendByte(address and $FF);
 getbyte;
 result:=0;
 result:=getbyte*$10000+result;
 result:=getbyte*$100+result;
 result:=getbyte+result;
 CommStop(ADLATCHPORT,ADLATCHVAL,ADNEG);
end;

function TAD1954.BiquadEQ(id:integer;safeload:boolean;freq,q,dBgain:real):boolean;
//vrati false, pokud nelze filtr vytvorit
var    a,omega,sn,cs,alpha:real;b0,b1,b2,a1,a2:real;l:longint;
    samplerate:integer;
begin
 samplerate:=48000;
 A:=mocnina(10,dbgain/40);
 omega:=2*pi*freq/samplerate;
 sn:=sin(omega);
 cs:=cos(omega);
 alpha:=sn/(2*q);
 b0:=(1+A*alpha)/(1+(alpha/a));
 b1:=-2*cs/(1+(alpha/A));
 b2:=(1-(alpha*a))/(1+(alpha/A));
 a1:=2*cs/(1+(alpha/A));
 a2:=-(1-(alpha/A))/(1+(alpha/a));
 if not ((b0>-1.999) and (b0<1.999) and
        (b1>-1.999) and (b1<1.999) and
        (b2>-1.999) and (b2<1.999) and
        (a1>-1.999) and (a1<1.999) and
        (a2>-1.999) and (a2<1.999)) then result:=false else begin
  result:=true;
  if not safeload then begin
    l:=RealTo220(b0);
    Cmd(5*id,l div $10000,(l div $100) and $FF,l and $FF);
    l:=RealTo220(b1);
    Cmd(5*id+1,l div $10000,(l div $100) and $FF,l and $FF);
    l:=RealTo220(b2);
    Cmd(5*id+2,l div $10000,(l div $100) and $FF,l and $FF);
    l:=RealTo220(a1);
    Cmd(5*id+3,l div $10000,(l div $100) and $FF,l and $FF);
    l:=RealTo220(a2);
    Cmd(5*id+4,l div $10000,(l div $100) and $FF,l and $FF);
  end else begin
    l:=RealTo220(b0);
    Cmd(265,5*id,l div $10000,(l div $100) and $FF,l and $FF);
    l:=RealTo220(b1);
    Cmd(266,5*id+1,l div $10000,(l div $100) and $FF,l and $FF);
    l:=RealTo220(b2);
    Cmd(267,5*id+2,l div $10000,(l div $100) and $FF,l and $FF);
    l:=RealTo220(a1);
    Cmd(268,5*id+3,l div $10000,(l div $100) and $FF,l and $FF);
    l:=RealTo220(a2);
    Cmd(269,5*id+4,l div $10000,(l div $100) and $FF,l and $FF);
    control1:=control1 or 512;
    SendControl1;
    sleep(1);
    control1:=control1 and ($FFFF-512);
    SendControl1;
  end;
 end;
end;

function TAD1954.BiquadGain(id:integer;safeload:boolean;dBgain:real):boolean;
//vrati false, pokud nelze filtr vytvorit
var b0,b1,b2,a1,a2:real;l:longint;
begin
begin
 b0:=mocnina(10,dbgain/20);
 b1:=0;b2:=0;a1:=0;a2:=0;
 if not ((b0>-1.999) and (b0<1.999) and
        (b1>-1.999) and (b1<1.999) and
        (b2>-1.999) and (b2<1.999) and
        (a1>-1.999) and (a1<1.999) and
        (a2>-1.999) and (a2<1.999)) then result:=false else begin
  result:=true;
  if not safeload then begin
    l:=RealTo220(b0);
    Cmd(5*id,l div $10000,(l div $100) and $FF,l and $FF);
    l:=RealTo220(b1);
    Cmd(5*id+1,l div $10000,(l div $100) and $FF,l and $FF);
    l:=RealTo220(b2);
    Cmd(5*id+2,l div $10000,(l div $100) and $FF,l and $FF);
    l:=RealTo220(a1);
    Cmd(5*id+3,l div $10000,(l div $100) and $FF,l and $FF);
    l:=RealTo220(a2);
    Cmd(5*id+4,l div $10000,(l div $100) and $FF,l and $FF);
  end else begin
    l:=RealTo220(b0);
    Cmd(265,5*id,l div $10000,(l div $100) and $FF,l and $FF);
    l:=RealTo220(b1);
    Cmd(266,5*id+1,l div $10000,(l div $100) and $FF,l and $FF);
    l:=RealTo220(b2);
    Cmd(267,5*id+2,l div $10000,(l div $100) and $FF,l and $FF);
    l:=RealTo220(a1);
    Cmd(268,5*id+3,l div $10000,(l div $100) and $FF,l and $FF);
    l:=RealTo220(a2);
    Cmd(269,5*id+4,l div $10000,(l div $100) and $FF,l and $FF);
    control1:=control1 or 512;
    SendControl1;
    sleep(1);
    control1:=control1 and ($FFFF-512);
    SendControl1;
  end;
 end;
end;
end;
                 //konstruktor, zakladni HW komunikace
constructor TAD1954.CreateLPT(PortAddr,CLatchPort,CLatchVal:integer;neg:boolean);   {vytvori objekt}
begin
 inherited Create;
 uselpt:=true;
 port:=PortAddr;
// showmessage(inttostr(clatchport));
 ADLATCHPORT:=CLatchPort;
 ADLATCHVAL:=CLatchVal;
 ADNEG:=neg;
 InitPort(PortAddr);
end;

procedure TAD1954.SendControl1;
begin
 Cmd(256,control1 div $100,control1 and $FF);
end;

procedure TAD1954.SendControl2;
begin
 Cmd(257,control2 div $100,control2 and $FF);
end;

procedure TAD1954.Init;                        {inicializuje AD1954}
begin
//init promennych
 control1:=0;
 control2:=7;
 volleft:=1;
 volright:=1;
 volsub:=1;
//ted inicializuj
 SetPowerDown(true);
 SendControl2;
 SetPowerDown(false);
end;


procedure TAD1954.NoVoltage(Value:boolean);    {pri pouziti LPT da pri
                                                        Reset=true vsechny piny
                                                        do nuly}
begin

end;

procedure TAD1954.Reset;
begin
 ResetAD(false);
 sleep(100);
 ResetAD(true);
 sleep(100);
end;


//ovladani kontr. registru
procedure TAD1954.SetMute(Value:boolean);
begin
 if value then control1:=control1 or 128 else control1:=control1 and ($FFFF-128);
 sendcontrol1;
end;
function TAD1954.GetMute:boolean;
begin
 result:=control1 and 128>0;
end;
procedure TAD1954.SetPowerDown(Value:boolean);
begin
 if value then control1:=control1 or 64 else control1:=control1 and ($FFFF-64);
 sendcontrol1;
end;
function TAD1954.GetPowerDown:boolean;
begin
 result:=control1 and 64>0;
end;
procedure TAD1954.SetDeemphasis(Value:TDeemph);
begin
 control1:=control1 and ($FFFF-48);
 if value=dee48 then control1:=control1 or 48;
 if value=dee44 then control1:=control1 or 16;
 if value=dee32 then control1:=control1 or 32;
 sendcontrol1;
end;
function TAD1954.GetDeemphasis:TDeemph;
begin
 case control1 and 48 of
  48:result:=dee48;
  16:result:=dee32;
  32:result:=dee44;
  else result:=deeNone;
 end;
end;
procedure TAD1954.SetVolumeRamp(Value:TVolRamp);
begin
 if value=vrSlow then control2:=control2 or 512 else control1:=control1 and ($FFFF-512);
 sendcontrol2;
end;
function TAD1954.GetVolumeRamp:TVolRamp;
begin
 if control1 and 512>0 then result:=vrSlow else result:=vrFast;
end;
procedure TAD1954.SetInput(Value:integer);
begin
 control2:=control2 and ($FFFF-64-128);
 control2:=control2+64*value;
 sendcontrol2;
end;
function TAD1954.GetInput:integer;
begin
 result:=(control2 and (64+128)) div 64;
end;
procedure TAD1954.SetMCLK(Value:integer);
begin
 control2:=control2 and ($FFFF-48);
 control2:=control2+16*value;
 sendcontrol2;
end;
function TAD1954.GetMCLK:integer;
begin
 result:=(control2 and 48) div 16;
end;


//hlasitost
procedure TAD1954.SetVolLeft(Value:real);
var i:integer;
begin
 i:=RealTo220(value);
 Cmd(258,i div $10000,(i and $FF00) div $100, i and $FF);
end;


procedure TAD1954.SetVolRight(Value:real);
var i:integer;
begin
 i:=RealTo220(value);
 Cmd(259,i div $10000,(i and $FF00) div $100, i and $FF);
end;


procedure TAD1954.SetVolSub(Value:real);
var i:integer;
begin
 i:=RealTo220(value);
 Cmd(260,i div $10000,(i and $FF00) div $100, i and $FF);
end;


procedure TAD1954.Cmd(addr:integer;data1,data2:byte);
begin
 CommStart(ADLATCHPORT,ADLATCHVAL,ADNEG);
 SendByte(addr div $100);
 SendByte(addr and $FF);
 SendByte(data1);
 SendByte(data2);
 CommStop(ADLATCHPORT,ADLATCHVAL,ADNEG);
end;


procedure TAD1954.Cmd(addr:integer;data1,data2,data3:byte);
begin
 CommStart(ADLATCHPORT,ADLATCHVAL,ADNEG);
 SendByte(addr div $100);
 SendByte(addr and $FF);
 SendByte(data1);
 SendByte(data2);
 SendByte(data3);
 CommStop(ADLATCHPORT,ADLATCHVAL,ADNEG);
end;

procedure TAD1954.Cmd(addr:integer;data1,data2,data3,data4:byte);
begin
 CommStart(ADLATCHPORT,ADLATCHVAL,ADNEG);
 SendByte(addr div $100);
 SendByte(addr and $FF);
 SendByte(data1);
 SendByte(data2);
 SendByte(data3);
 SendByte(data4);
 CommStop(ADLATCHPORT,ADLATCHVAL,ADNEG);
end;

procedure TAD1954.Cmd(addr:integer;data220:real);
var i:integer;
begin
 i:=RealTo220(data220);
 CommStart(ADLATCHPORT,ADLATCHVAL,ADNEG);
 SendByte(addr div $100);
 SendByte(addr and $FF);
 SendByte(i div $10000);
 SendByte((i div $100) and $FF);
 SendByte(i and $FF);
 CommStop(ADLATCHPORT,ADLATCHVAL,ADNEG);
end;

procedure TAD1954.CmdSafe(addr:integer;data220:real);
var l:integer;
begin
 l:=RealTo220(data220);
 Cmd(265,addr,l div $10000,(l div $100) and $FF,l and $FF);
 control1:=control1 or 512;
 SendControl1;
 sleep(1);
 control1:=control1 and ($FFFF-512);
 SendControl1;
end;


end.
